Notice
Recent Posts
Recent Comments
Link
일 | 월 | 화 | 수 | 목 | 금 | 토 |
---|---|---|---|---|---|---|
1 | 2 | 3 | 4 | 5 | 6 | 7 |
8 | 9 | 10 | 11 | 12 | 13 | 14 |
15 | 16 | 17 | 18 | 19 | 20 | 21 |
22 | 23 | 24 | 25 | 26 | 27 | 28 |
29 | 30 | 31 |
Tags
- 투포인터
- 코테
- LIS #Algorithm #요소추적
- 식단
- 백준
- c++
- BFS
- BaekJoon
- Union-find
- 코딩테스트
- 소감
- 중반부
- 삼성 #코테 #2020상반기 #c++
- Smilegate
- 카카오
- 1편
- 서버개발캠프
- 알고리즘
- 카카오인턴
- IBK기업은행 #기업은행 #디지털 #직무 #정리
- 유니온파인드
- 스마일게이트
- 보석쇼핑
- Algorithm
Archives
- Today
- Total
짱아의 개발 기록장
LeetCode : 11. Container With Most Water 본문
반응형
생각보다 이런 유형의 문제들이 여러 기업들의 코딩테스트에 많이 출제된다.
거의 대부분 이런 문제들은 투포인터로 푸는 것이 시간복잡도를 줄일 수 있는 현명한 방법이다.
물론, Brute Force로 풀 수 있겠지만... O(n^2)이면 크기에 따라 Time Limit이 찍힐 수도 있다.
LeetCode의 경우 C++기준으로 Time Limit이 뜬다.
투포인터
시간복잡도 : O(n)
1
2
3
4
5
6
7
8
9
10
11
12
13
14
15
16
17
18
19
20
21
22
23
24
25
26
27
|
// Two-pointer
class Solution {
public:
int maxArea(vector<int>& height) {
// 어차피 짧은 높이에 의해 넓이가 결정되기 때문에
// 맨끝 양쪽에서 시작해서 둘 중 짧은 것을 다음으로 넘어간다.
int Start = 0;
int End = height.size()-1;
int ans = 0;
while(Start<End){
if(height[Start]<height[End]){
if(ans<height[Start]*(End-Start)){
ans = height[Start]*(End-Start);
}
Start++;
}else{
if(ans<height[End]*(End-Start)){
ans = height[End]*(End-Start);
}
End--;
}
}
return ans;
}
};
|
cs |
반응형
'Algorithm > LeetCode' 카테고리의 다른 글
LeetCode : 98. Validate Binary Search Tree (0) | 2020.12.29 |
---|---|
LeedCode : 17. Letter Combinations of a Phone Number (0) | 2020.12.29 |
LeetCode : 9. Palindrome Number (0) | 2020.12.28 |
LeetCode : 7. Reverse Integer (0) | 2020.12.27 |
LeetCode : 6. ZigZag Conversion (0) | 2020.12.27 |
Comments